%define scanf_has_m 1
%define separate_devel_static 1

Distribution:	CCux
Packager:  	Christian Metzen <metzench@ccux-linux.de>

Summary: 	A collection of utilities and DSOs to handle compiled objects
Name:      	elfutils
Version:   	0.151
Release:   	1
License:   	GNU/GPL
URL:	   	https://fedorahosted.org/releases/e/l/elfutils/
Group:     	System/Base    
Source: 	elfutils-%{version}.tar.bz2
Patch0:		elfutils-readelf_datatype.patch
Requires: 	elfutils-libelf-%{_arch} = %{version}-%{release}
Requires: 	elfutils-libs-%{_arch} = %{version}-%{release}
BuildRoot: 	%{_tmppath}/%{name}-buildroot
BuildArch:	i686

%define _gnu %{nil}
%define _program_prefix eu-

# ensure playload compression algorithm to be bz2
# for compatibility reasons
%define _source_payload w9.bzdio
%define _binary_payload w9.bzdio

BuildRequires:  bison flex bzip2 binutils grep

#Automatically resolved build dependencies
BuildRequires: bzip2-devel
BuildRequires: glibc-devel
BuildRequires: xz-devel
BuildRequires: zlib-devel

%description
Elfutils is a collection of utilities, including ld (a linker),
nm (for listing symbols from object files), size (for listing the
section sizes of an object or archive file), strip (for discarding
symbols), readelf (to see the raw ELF file structures), and elflint
(to check for well-formed ELF files).


%package libs
Summary: 	Libraries to handle compiled objects.
Group: 		Development/Tools
License: 	GPL
Provides: 	elfutils-libs-%{_arch} = %{version}-%{release}
Requires: 	elfutils-libelf-%{_arch} = %{version}-%{release}

%description libs
The elfutils-libs package contains libraries which implement DWARF, ELF,
and machine-specific ELF handling.  These libraries are used by the programs
in the elfutils package.  The elfutils-devel package enables building
other programs using these libraries.

%package devel
Summary: 	Development libraries to handle compiled objects.
Group: 		Development/Tools
License: 	GPL
Provides: 	elfutils-devel-%{_arch} = %{version}-%{release}
Requires: 	elfutils-libs-%{_arch} = %{version}-%{release}
Requires: 	elfutils-libelf-devel-%{_arch} = %{version}-%{release}
%if !0%{?separate_devel_static}
Requires: 	elfutils-devel-static-%{_arch} = %{version}-%{release}
%endif

%description devel
The elfutils-devel package contains the libraries to create
applications for handling compiled objects.  libebl provides some
higher-level ELF access functionality.  libdw provides access to
the DWARF debugging information.  libasm provides a programmable
assembler interface.

%package devel-static
Summary: 	Static archives to handle compiled objects.
Group: 		Development/Tools
Provides: 	elfutils-devel-static-%{_arch} = %{version}-%{release}
Requires: 	elfutils-devel-%{_arch} = %{version}-%{release}
Requires: 	elfutils-libelf-devel-static-%{_arch} = %{version}-%{release}

%description devel-static
The elfutils-devel-static package contains the static archives
with the code to handle compiled objects.

%package libelf
Summary: 	Library to read and write ELF files.
Group: 		Development/Tools
Provides: 	elfutils-libelf-%{_arch} = %{version}-%{release}

%description libelf
The elfutils-libelf package provides a DSO which allows reading and
writing ELF files on a high level.  Third party programs depend on
this package to read internals of ELF files.  The programs of the
elfutils package use it also to generate new ELF files.

%package libelf-devel
Summary: 	Development support for libelf
Group: 		Development/Tools
Provides: 	elfutils-libelf-devel-%{_arch} = %{version}-%{release}
Requires: 	elfutils-libelf-%{_arch} = %{version}-%{release}
Conflicts: 	libelf-devel
%if !0%{?separate_devel_static}
Requires: 	elfutils-libelf-devel-static-%{_arch} = %{version}-%{release}
%endif

%description libelf-devel
The elfutils-libelf-devel package contains the libraries to create
applications for handling compiled objects.  libelf allows you to
access the internals of the ELF object file format, so you can see the
different sections of an ELF file.

%package libelf-devel-static
Summary: 	Static archive of libelf
Group: 		Development/Tools
Provides: 	elfutils-libelf-devel-static-%{_arch} = %{version}-%{release}
Requires: 	elfutils-libelf-devel-%{_arch} = %{version}-%{release}

%description libelf-devel-static
The elfutils-libelf-static package contains the static archive
for libelf.

%prep
%setup -q
# fix unsigned int to signed int comparison warning in readelf 
# by typecasting to unsigned int
%patch0 -p1

find . -name \*.sh ! -perm -0100 -print | xargs chmod +x

%if !0%{?scanf_has_m}
sed -i.scanf-m -e 's/%m/%a/g' src/addr2line.c tests/line2addr.c
%endif

%build
# Remove -Wall from default flags.  The makefiles enable enough warnings
# themselves, and they use -Werror.  Appending -Wall defeats the cases where
# the makefiles disable some specific warnings for specific code.
RPM_OPT_FLAGS=${RPM_OPT_FLAGS/-Wall/}

%configure CFLAGS="$RPM_OPT_FLAGS -fexceptions"
make -s %{?_smp_mflags}

%install
rm -rf ${RPM_BUILD_ROOT}
make -s install DESTDIR=${RPM_BUILD_ROOT}

chmod +x ${RPM_BUILD_ROOT}%{_prefix}/%{_lib}/lib*.so*
chmod +x ${RPM_BUILD_ROOT}%{_prefix}/%{_lib}/elfutils/lib*.so*

# XXX Nuke unpackaged files
(cd ${RPM_BUILD_ROOT}
 rm -f .%{_bindir}/eu-ld
)


%check
#make -s check

%clean
rm -rf ${RPM_BUILD_ROOT}

%post libs -p /sbin/ldconfig

%postun libs -p /sbin/ldconfig

%post libelf -p /sbin/ldconfig

%postun libelf -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc README TODO
%{_bindir}/eu-addr2line
%{_bindir}/eu-ar
%{_bindir}/eu-elfcmp
%{_bindir}/eu-elflint
%{_bindir}/eu-findtextrel
%{_bindir}/eu-nm
%{_bindir}/eu-objdump
%{_bindir}/eu-ranlib
%{_bindir}/eu-readelf
%{_bindir}/eu-size
%{_bindir}/eu-strings
%{_bindir}/eu-strip
%{_bindir}/eu-unstrip
%{_bindir}/eu-make-debug-archive
%{_locale}/*/LC_MESSAGES/elfutils.mo

%files libs
%defattr(-,root,root)
%{_libdir}/libdw-%{version}.so
%{_libdir}/libdw.so.*
%dir %{_libdir}/elfutils
%{_libdir}/elfutils/lib*.so
%{_libdir}/libasm*

%files devel
%defattr(-,root,root)
%{_includedir}/dwarf.h
%{_includedir}/elfutils/elf-knowledge.h
%{_includedir}/elfutils/libebl.h
%{_includedir}/elfutils/libdw.h
%{_includedir}/elfutils/libdwfl.h
%{_includedir}/elfutils/libasm.h
%{_includedir}/elfutils/version.h
%{_libdir}/libebl.a
%{_libdir}/libdw.so

%files devel-static
%defattr(-,root,root)
%{_libdir}/libdw.a

%files libelf
%defattr(-,root,root)
%{_libdir}/libelf-%{version}.so
%{_libdir}/libelf.so.*

%files libelf-devel
%defattr(-,root,root)
%{_includedir}/libelf.h
%{_includedir}/gelf.h
%{_includedir}/nlist.h
%{_libdir}/libelf.so

%files libelf-devel-static
%defattr(-,root,root)
%{_libdir}/libelf.a

%changelog
* Mon Jan 24 2011 Karsten Brockmann <arcam@ccux-linux.de> 0.151-1
- version update
* Sun Oct 17 2010 Karsten Brockmann <arcam@ccux-linux.de> 0.149-1
- version update
* Wed Aug 26 2009 Karsten Brockmann <arcam@ccux-linux.de> 0.142-1
- version update
* Tue Jun 17 2009 Karsten Brockmann <arcam@ccux-linux.de> 0.141-1
- version update
* Thu Jan 24 2008 Christian Metzen <metzench@ccux-linux.de> 0.132-1
- Version update
- changed packaging to reflect prelink setup
* Fri Nov 23 2007 Karsten Brockmann <arcam@ccux-linux.de> 0.131-1
- version update
* Sun Jan 21 2007 Karsten Brockmann <arcam@ccux-linux.de> 0.125-1
- version update
* Wed Sep 13 2006 Karsten Brockmann <arcam@ccux-linux.de> 0.123-1
- version update
* Sun Aug 27 2006 Karsten Brockmann <arcam@ccux-linux.de> 0.122-1
- rebuilt spec
* Sun Dec 26 2004 Christian Metzen <metzench@ccux-linux.de> 0.95-1
- initial release
